diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
index b93cf2b38..c4b158c72 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSoulSand.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.World;
@@ -12,12 +13,20 @@ import org.joml.primitives.AABBdc;
 
 public class BlockLogicSoulSand extends BlockLogic
 {
+    public static final Int2IntArrayMap pocketVariantMap = new Int2IntArrayMap();
 
     public BlockLogicSoulSand(Block<?> block)
     {
         super(block, Materials.SOUL_SAND);
     }
 
+    static {
+        pocketVariantMap.put(Blocks.GLOOMSTONE.id(), Blocks.SOULSAND.id());
+        pocketVariantMap.put(Blocks.COBBLE_GLOOMSTONE.id(), Blocks.SOULSAND.id());
+        pocketVariantMap.put(Blocks.BLOCK_ASH.id(), Blocks.SOULSAND.id());
+        pocketVariantMap.put(Blocks.SLATE.id(), Blocks.SOULSAND.id());
+    }
+
     @Override
     public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         double f = 2/16d;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
index 4570f258a..b904c1c85 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSulfur.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.ints.Int2IntArrayMap;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -10,22 +10,22 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Random;
-
 public class BlockLogicSulfur extends BlockLogic {
+	public static final Int2IntArrayMap pocketVariantMap = new Int2IntArrayMap();
 
 	public BlockLogicSulfur(@NotNull Block<?> block) {
 		super(block, Materials.SOUL_SAND);
-		block.setTicking(true);
+	}
+
+	static {
+		pocketVariantMap.put(Blocks.BRIMSTONE.id(), Blocks.SULFUR.id());
+		pocketVariantMap.put(Blocks.BRIMSAND.id(), Blocks.SULFUR.id());
 	}
 
 	@Override
@@ -36,11 +36,6 @@ public class BlockLogicSulfur extends BlockLogic {
 		};
 	}
 
-	@Override
-	public int tickDelay() {
-		return 20;
-	}
-
 	@Override
 	public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Block<?> block) {
 		world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
@@ -51,32 +46,6 @@ public class BlockLogicSulfur extends BlockLogic {
 		world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay() + world.rand.nextInt(5) - world.rand.nextInt(5));
 	}
 
-	public boolean canMelt(@NotNull World world, @NotNull TilePosc tilePos) {
-		int acidCount = 0;
-		TilePos queryPos = new TilePos();
-
-		for (Direction dir : Direction.ID_MAP) {
-			Block<?> block = world.getBlockType(tilePos.add(dir, queryPos));
-			Material adjacentMaterial = block.getMaterial();
-			if (adjacentMaterial == Materials.LAVA) return false;
-			if (adjacentMaterial == Materials.WATER) return false;
-			if (adjacentMaterial == Materials.ACID) {
-				acidCount++;
-			}
-		}
-
-		return acidCount >= 3;
-	}
-
-	@Override
-	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
-		if (this.canMelt(world, tilePos)) {
-			world.playBlockEvent(tilePos, LevelListener.EVENT_ACID_SPREAD, 0);
-			world.setBlockTypeNotify(tilePos, Blocks.FLUID_ACID_FLOWING);
-		}
-
-	}
-
 	@Override
 	public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
 		world.playSoundEffect(
@@ -97,14 +66,14 @@ public class BlockLogicSulfur extends BlockLogic {
 		super.onDestroyedByPlayer(world, tilePos, side, data, player, item);
 
 		world.playSoundEffect(
-				player,
-				SoundCategory.WORLD_SOUNDS,
-				tilePos.x() + 0.5,
-				tilePos.y() + 0.5,
-				tilePos.z() + 0.5,
-				"step.stone",
-				1.0F,
-				0.8F
+			player,
+			SoundCategory.WORLD_SOUNDS,
+			tilePos.x() + 0.5,
+			tilePos.y() + 0.5,
+			tilePos.z() + 0.5,
+			"step.stone",
+			1.0F,
+			0.8F
 		);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
index ce20f709a..04f08add0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -1,8 +1,13 @@
 package net.minecraft.core.block;
 
+import it.unimi.dsi.fastutil.longs.Long2IntOpenHashMap;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePos;
@@ -19,6 +24,15 @@ public class BlockLogicThermalVent extends BlockLogic {
     public static int DORMANT_STATE = 0;
     public static int VENTING_STATE = 4;
 
+    private static final Long2IntOpenHashMap STACKED_VENT_OWNERS = new Long2IntOpenHashMap();
+
+    private static long packStackedVentKey(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return ((long) world.getDimension().id << 60)
+            | ((long) (tilePos.x() & 0x3FFFFF) << 40)
+            | ((long) (tilePos.z() & 0x3FFFFF) << 20)
+            | (long) (tilePos.y() & 0xFFFFF);
+    }
+
     public BlockLogicThermalVent(final @NotNull Block<?> block) {
         super(block, Materials.BASALT);
         block.setTicking(true);
@@ -134,17 +148,48 @@ public class BlockLogicThermalVent extends BlockLogic {
 
 
         if (!world.isClientSide) {
+            final long ventKey = packStackedVentKey(world, tilePos);
+            final int ownerId = STACKED_VENT_OWNERS.containsKey(ventKey) ? STACKED_VENT_OWNERS.remove(ventKey) : -1;
             alertNearbyPlayers(world, tilePos);
 
             final List<Entity> entities = world.getEntitiesWithinAABB(Entity.class, new AABBd(tilePos.x() - 1, tilePos.y(), tilePos.z() - 1, tilePos.x() + 2, tilePos.y() + 7, tilePos.z() + 2));
             for (final @NotNull Entity entity : entities) {
                 entity.fling(0, 2, 0, 1f);
+                if (entity instanceof Player player) {
+                    player.addStat(Achievements.FLING_VENT, 1);
+                }
+            }
+
+            if (ownerId != -1) {
+                for (final Player player : world.players) {
+                    if (player.id == ownerId) {
+                        player.addStat(Achievements.WHAT_WAS_THAT, 1);
+                        break;
+                    }
+                }
             }
 
             world.setBlockData(tilePos, DORMANT_STATE);
         }
     }
 
+    @Override
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+        if (!world.isClientSide && mob instanceof Player player
+            && world.getDimension() == Dimension.OVERWORLD
+            && hasVentBelow(world, tilePos)) {
+            STACKED_VENT_OWNERS.put(packStackedVentKey(world, tilePos), player.id);
+        }
+    }
+
+    @Override
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        super.onRemoved(world, tilePos, data);
+        if (!world.isClientSide) {
+            STACKED_VENT_OWNERS.remove(packStackedVentKey(world, tilePos));
+        }
+    }
+
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidHardening.java b/game/core/src/main/java/net/minecraft/core/block/FluidHardening.java
index fef77ac99..2e6e82020 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidHardening.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidHardening.java
@@ -1,14 +1,19 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.Materials;
-import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public final class FluidHardening {
+    private static final int RECENT_PLACEMENT_TICKS = 240;
+    private static final double RECENT_PLACEMENT_RADIUS_SQ = 16.0 * 16.0;
+
     private FluidHardening() {
     }
 
@@ -59,6 +64,7 @@ public final class FluidHardening {
             world.setBlockTypeNotify(tilePos, data == 0 ? Blocks.OBSIDIAN : Blocks.GLOOMSTONE);
         } else {
             world.setBlockTypeNotify(tilePos, Blocks.LIMESTONE);
+            notifyAcidStoneCreated(world, tilePos, Blocks.LIMESTONE);
         }
         BlockLogicFluid.fizz(world, tilePos);
         return true;
@@ -89,10 +95,13 @@ public final class FluidHardening {
             world.setBlockTypeNotify(tilePos, Blocks.OBSIDIAN);
         } else if (data <= 2) {
             world.setBlockTypeNotify(tilePos, Blocks.GRANITE);
+            notifyAcidStoneCreated(world, tilePos, Blocks.GRANITE);
         } else if (data <= 4) {
             world.setBlockTypeNotify(tilePos, Blocks.STONE);
+            notifyAcidStoneCreated(world, tilePos, Blocks.STONE);
         } else {
             world.setBlockTypeNotify(tilePos, Blocks.BASALT);
+            notifyAcidStoneCreated(world, tilePos, Blocks.BASALT);
         }
         BlockLogicFluid.fizz(world, tilePos);
         return true;
@@ -101,10 +110,26 @@ public final class FluidHardening {
     private static boolean hardenAcidWithLava(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos) & 0x0F;
         if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
-            world.setBlockTypeNotify(tilePos, data == 0 ? Blocks.BRIMTHAW : Blocks.BRIMSTONE);
-            fizzAcidNether(world, tilePos);
-        } else {
-            hardenAcidOverworld(world, tilePos, data);
+            if(data == 0) {
+                world.setBlockTypeNotify(tilePos, Blocks.BRIMTHAW);
+            } else {
+                world.setBlockTypeNotify(tilePos, Blocks.BRIMSTONE);
+            }
+        }
+        else {
+            if (data == 0) {
+                world.setBlockTypeNotify(tilePos, Blocks.BRIMTHAW);
+            } else if (data <= 2) {
+                world.setBlockTypeNotify(tilePos, Blocks.GRANITE);
+                notifyAcidStoneCreated(world, tilePos, Blocks.GRANITE);
+            } else if (data <= 4) {
+                world.setBlockTypeNotify(tilePos, Blocks.STONE);
+                notifyAcidStoneCreated(world, tilePos, Blocks.STONE);
+            } else {
+                world.setBlockTypeNotify(tilePos, Blocks.BASALT);
+                notifyAcidStoneCreated(world, tilePos, Blocks.BASALT);
+            }
+            BlockLogicFluid.fizz(world, tilePos);
         }
         return true;
     }
@@ -112,31 +137,65 @@ public final class FluidHardening {
     private static boolean hardenAcidWithWater(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos) & 0x0F;
         if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
-            world.setBlockTypeNotify(tilePos, data == 0 ? Blocks.BRIMTHAW : Blocks.BRIMSTONE);
-            fizzAcidNether(world, tilePos);
-        } else {
-            hardenAcidOverworld(world, tilePos, data);
+            if(data == 0) {
+                world.setBlockTypeNotify(tilePos, Blocks.BRIMTHAW);
+            } else {
+                world.setBlockTypeNotify(tilePos, Blocks.BRIMSTONE);
+            }
+        }
+        else {
+            if (data == 0) {
+                world.setBlockTypeNotify(tilePos, Blocks.SULFUR);
+                notifyAcidConvertedToSulfur(world, tilePos);
+            } else if (data <= 2) {
+                world.setBlockTypeNotify(tilePos, Blocks.GRANITE);
+                notifyAcidStoneCreated(world, tilePos, Blocks.GRANITE);
+            } else if (data <= 4) {
+                world.setBlockTypeNotify(tilePos, Blocks.STONE);
+                notifyAcidStoneCreated(world, tilePos, Blocks.STONE);
+            } else {
+                world.setBlockTypeNotify(tilePos, Blocks.BASALT);
+                notifyAcidStoneCreated(world, tilePos, Blocks.BASALT);
+            }
+            BlockLogicFluid.fizz(world, tilePos);
         }
         return true;
     }
 
-    private static void hardenAcidOverworld(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
-        if (data == 0) {
-            world.setBlockTypeNotify(tilePos, Blocks.SULFUR);
-        } else if (data <= 2) {
-            world.setBlockTypeNotify(tilePos, Blocks.GRANITE);
-        } else if (data <= 4) {
-            world.setBlockTypeNotify(tilePos, Blocks.STONE);
-        } else {
-            world.setBlockTypeNotify(tilePos, Blocks.BASALT);
+    private static void notifyAcidStoneCreated(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (world.isClientSide || !Block.hasLogicClass(block, BlockLogicStone.class)) {
+            return;
+        }
+        final Player credit = findRecentPlacer(world, tilePos, true);
+        if (credit != null) {
+            credit.addStat(Achievements.CONVERT_ACID_TO_STONE, 1);
+        }
+    }
+
+    private static void notifyAcidConvertedToSulfur(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        if (world.isClientSide) {
+            return;
+        }
+        Player credit = findRecentPlacer(world, tilePos, true);
+        if (credit == null) {
+            credit = findRecentPlacer(world, tilePos, false);
+        }
+        if (credit != null) {
+            credit.addStat(Achievements.CONVERT_ACID_TO_SULFUR, 1);
         }
-        BlockLogicFluid.fizz(world, tilePos);
     }
 
-    private static void fizzAcidNether(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
-        for (int i = 0; i < 8; ++i) {
-            world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + 1.01, (double) tilePos.z() + Math.random(), 0.0F, 0.0F, 0.0F, 0, false);
+    private static @Nullable Player findRecentPlacer(final @NotNull World world, final @NotNull TilePosc tilePos, final boolean acid) {
+        final long now = world.getTotalWorldTime();
+        final int dimensionId = world.getDimension().id;
+        for (final Player player : world.players) {
+            final Player.FluidPlacement placement = acid ? player.lastAcidPlacement : player.lastWaterPlacement;
+            if (placement == null) continue;
+            if (placement.dimensionId() != dimensionId) continue;
+            if (now - placement.tick() > RECENT_PLACEMENT_TICKS) continue;
+            if (tilePos.distanceSquared(placement.x(), placement.y(), placement.z()) > RECENT_PLACEMENT_RADIUS_SQ) continue;
+            return player;
         }
+        return null;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 087ecd16f..189a41fec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -323,7 +323,7 @@ public class BlockLogicPistonBase extends BlockLogic {
         // note that flingEntity is performed before flingBlock, therefore no need to 
         // check for flingBlock
         for (final var entity : entities) {
-            if (entity.noPhysics) continue;
+            if (entity.hasNoPhysics()) continue;
             entity.fling(vx, vy, vz, 1f);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 158c6cec8..e011cab22 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -157,7 +157,7 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
 
             final var entities = this.worldObj.getEntitiesWithinAABBExcludingEntity(null, this.sweptCollision);
             for (final var e : entities) {
-                if (e.noPhysics) continue;
+                if (e.hasNoPhysics()) continue;
                 e.move(dir.x, dir.y, dir.z);
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
index 0c44fe617..620ab5f79 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
@@ -10,6 +10,7 @@ import net.minecraft.core.data.registry.recipe.entry.*;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.*;
 
@@ -165,13 +166,19 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
     }
 
     public ItemStack findMatchingRecipe(ContainerCrafting inventorycrafting)
+    {
+        RecipeEntryCrafting<?, ?> recipe = findMatchingCraftingRecipe(inventorycrafting);
+        return recipe != null ? recipe.getCraftingResult(inventorycrafting) : null;
+    }
+
+    public @Nullable RecipeEntryCrafting<?, ?> findMatchingCraftingRecipe(ContainerCrafting inventorycrafting)
     {
         for(int i = 0; i < getAllCraftingRecipes().size(); i++)
         {
             RecipeEntryCrafting<?,?> recipe = getAllCraftingRecipes().get(i);
             if(recipe.matches(inventorycrafting))
             {
-                return recipe.getCraftingResult(inventorycrafting);
+                return recipe;
             }
         }
 
@@ -180,16 +187,8 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
 
     public ItemStack[] onCraftResult(ContainerCrafting inventorycrafting)
     {
-        for(int i = 0; i < getAllCraftingRecipes().size(); i++)
-        {
-            RecipeEntryCrafting<?,?> recipe = getAllCraftingRecipes().get(i);
-            if(recipe.matches(inventorycrafting))
-            {
-                return recipe.onCraftResult(inventorycrafting);
-            }
-        }
-
-        return null;
+        RecipeEntryCrafting<?, ?> recipe = findMatchingCraftingRecipe(inventorycrafting);
+        return recipe != null ? recipe.onCraftResult(inventorycrafting) : null;
     }
 
     public void addRecipe(String recipeKey, ItemStack itemstack, boolean consumeContainerItem, Object... aobj) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index c37a5bb63..d23c84461 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -49,6 +49,7 @@ public abstract class Entity
     public static final int FLAG_SNEAKING = 1;
     public static final int FLAG_RIDING = 2;
     public static final int FLAG_SPRINTING = 3;
+    public static final int FLAG_NO_PHYSICS = 4;
 
     // Misc/IDK
     public boolean slide = true;
@@ -96,7 +97,6 @@ public abstract class Entity
     private final @NotNull AABBd workingBox4 = new AABBd();
 
     // Movement/Physics
-    public boolean noPhysics = false;
     public float pushthrough = 0.0F;
     public float walkDistO = 0.0F;
     public float walkDist = 0.0F;
@@ -432,7 +432,7 @@ public abstract class Entity
     }
 
     public void move(double xd, double yd, double zd) {
-        if (this.noPhysics) {
+        if (hasNoPhysics()) {
             this.onGround = false;
             this.bb.translate(xd, yd, zd);
             this.x = (this.bb.minX + this.bb.maxX) / 2.0;
@@ -743,7 +743,7 @@ public abstract class Entity
     }
 
     protected void checkFallDamage(final double yd, final boolean onGround) {
-        if (this.vehicle != null || this.noPhysics) {
+        if (this.vehicle != null || hasNoPhysics()) {
             this.fallDistance = 0;
         } else if (onGround) {
             if (this.fallDistance > 0.0F) {
@@ -1091,7 +1091,7 @@ public abstract class Entity
     }
 
     public void push(@NotNull Entity entity) {
-        if (entity.passenger == this || entity.vehicle == this || entity.noPhysics || !entity.isPickable() || !this.collidesWith(entity) || !entity.collidesWith(this)) {
+        if (entity.passenger == this || entity.vehicle == this || entity.hasNoPhysics() || !entity.isPickable() || !this.collidesWith(entity) || !entity.collidesWith(this)) {
             return;
         }
 
@@ -1465,6 +1465,14 @@ public abstract class Entity
         setSharedFlag(FLAG_SNEAKING, flag);
     }
 
+    public boolean hasNoPhysics() {
+        return getSharedFlag(FLAG_NO_PHYSICS);
+    }
+
+    public void setNoPhysics(boolean flag) {
+        setSharedFlag(FLAG_NO_PHYSICS, flag);
+    }
+
     protected boolean getSharedFlag(int i) {
         return (this.entityData.getByte(0) & 1 << i) != 0;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 41355d1ae..67cee9925 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -221,6 +221,15 @@ public class EntityItem extends Entity
                 }
                 if(this.item.itemID == Items.NETHERCOAL.id) {
                     player.triggerAchievement(Achievements.GET_NETHERCOAL);
+                }
+                if(this.item.itemID == Items.INGOT_STEEL.id) {
+                    player.triggerAchievement(Achievements.OBTAIN_STEEL);
+                }
+                if(this.item.itemID == Items.RUBYGLASS.id) {
+                    player.triggerAchievement(Achievements.COLLECT_RUBYGLASS);
+                }
+                if(this.item.itemID == Blocks.PUMICE_WET.id()) {
+                    player.triggerAchievement(Achievements.COLLECT_PUMICE);
                 }
 				if(this.item.itemID == Blocks.ICE.id()) {
 					player.triggerAchievement(Achievements.CRUSH_BLOCKS);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java
index 4cd2339ae..cdcc39bc0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItemHoming.java
@@ -51,7 +51,7 @@ public class EntityItemHoming extends EntityItem {
                 }
 
                 if (this.homingTicks > 10) {
-                    this.noPhysics = true;
+                    setNoPhysics(true);
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 8b3ded235..153d56e63 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -286,7 +286,7 @@ public abstract class Mob extends Entity {
             this.livingSoundTime = -getAmbientSoundInterval();
             playLivingSound();
         }
-        if (isAlive() && isInWall() && !this.noPhysics) {
+        if (isAlive() && isInWall() && !hasNoPhysics()) {
             hurt(null, 1, null);
         }
         if (this.fireImmune || this.world.isClientSide) {
@@ -693,7 +693,7 @@ public abstract class Mob extends Entity {
         this.muteStepSounds = false;
         this.isSkating = false;
 
-        if (this.noPhysics) {
+        if (hasNoPhysics()) {
             int vertical = 0;
             if (isSneaking()) vertical--;
             if (this.isJumping) vertical++;
@@ -992,7 +992,7 @@ public abstract class Mob extends Entity {
     }
 
     protected void jump() {
-        if (this.noPhysics) {
+        if (hasNoPhysics()) {
             return;
         }
         this.yd = this.jumpHeight;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
index 12e6eb0e4..f87d16447 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
@@ -78,17 +78,18 @@ public class MobCow
         return 0.4F;
     }
 
-    @Override
-    public boolean interact(@NotNull Player player) {
-        ItemStack itemstack = player.inventory.getCurrentItem();
-
-        if (itemstack != null && itemstack.getItem() instanceof ItemBucket) {
-            ItemBucket.useBucket(itemstack, player, this.world, ItemBucket.STATE_MILK);
-            return true;
-        }
-
-        return super.interact(player);
-    }
+    // // upstream design makes implementing it here not ideal
+    // @Override
+    // public boolean interact(@NotNull Player player) {
+    //     ItemStack itemstack = player.inventory.getCurrentItem();
+
+    //     if (itemstack != null && itemstack.getItem() instanceof ItemBucket) {
+    //         ItemBucket.useBucket(itemstack, player, this.world, ItemBucket.STATE_MILK);
+    //         return true;
+    //     }
+
+    //     return super.interact(player);
+    // }
 
     @Override
     public boolean isFavouriteItem(ItemStack itemStack)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
index 5fbd9c81f..c939dfa40 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonsterArmored.java
@@ -23,7 +23,7 @@ public abstract class MobMonsterArmored<T extends IArmorShape>
 
     protected static final int DATA_ITEM_HELD = 24;
     protected static final int DATA_ARMOR_START = 25;
-    protected static final int FLAG_LEFT_HANDED = 4;
+    protected static final int FLAG_LEFT_HANDED = 5;
 
     public MobMonsterArmored(final @NotNull World world) {
         super(world);
